#
#Constant declaration
debugLog="..\log\fw1Debug.Log"
tracing=0

if [[ tracing -eq 1 ]] 
then
  echo "Opened log file $debuglog" > debugLog
fi

#Parameter handling
#Check whether "Temporary File 1" is specified
if [[ $# -eq 0 ]] 
then
  echo "ERROR: 'Temporary File 1' is not specified" >> debugLog
  exit 1
fi

if [[ $# -ge 2 ]] 
then
   echo "ERROR: Too many properties specified" >> debugLog
   exit 1
fi

#Get properties as passed by ExtendIT toolkit.
outFileName=$1
fw1Dir="\bin\fw1\4.1"

if [[ $# -ge 1 ]] 
then
  if [ $1 <> " " && $1 <> "" ]
  then
    fw1Dir=$1;
  fi
fi

if [[ tracing -eq 1 ]] 
then
  echo "outFileName: $outFileName" >> debugLog
  echo "fw1Dir: $fw1Dir" >> debugLog
fi

#Does the path to the FireWall-1 software really exist?

if [ ! -d $fw1Dir ]
then
  echo "ERROR: The path to the FireWall-1 software ( $fw1Dir ) does not exist" >> debugLog
  exit 1
fi

#The FireWall-1 Command

fw="$fwdir\bin\fw"
echo "Temporary File 1: $outFileName" >> debugLog

#Tell the firewall to switch it's log

newAuditLogFileName=`date +%Y%m%d%H%M%S`
switchedLogFile="$fw1Dir\log\$newAuditLogFileName.log"
$fw "logswitch" $newAuditLogFileName

if [ ! -e $switchedLogFile ]
then
  echo "ERROR: the fw command failed, while switching logs; the expected file $switchedLogFile was not found" >> debugLog
  exit 2
else
#Tell the firewall to export it's log
  $fw logexport -n -i $switchedLogFile -o $outFileName
  if [ ! -e $outFileName ]
  then
    echo "ERROR: the fw command failed, while exporting; the expected file $outFileName was not found" >> debugLog
    exit 3
  fi
fi
