#Copy arguments to named parameters
OutputFile=$1
Host=$2
Username=$3
Password=$4
CopySubVolume=$5
AuditPrefix=$6

#Create LogFile
LogFileName="gettandem${Host}.log"
tmpfilelistname="outfilelist"`date +%y%m%d%H%M%S`
tmpfilelistname1="out"`date +%y%m%d%H%M%S`
tmpfile="genact-tandem.tmp"

exitf () {
  rm $OutputFile
  if [ -e $tmpfilelistname ]
  then 
    echo "Removing local file $OutputFile"  >> $LogFileName
    rm $tmpfilelistname
  fi
  if [ -e $tmpfilelistname1 ]
  then 
    rm $tmpfilelistname1 
  fi
  exit 1
}

echo "CeA Tandem Actuator [gettandemloscript.sh], "`date "+%Y/%m/%d %H:%M:%S"` > $LogFileName
if [ ! -e $LogFileName ]
then 
  echo "Unable to create logfile"
fi

#Get local directory from OutputFile
LocalDirPrefix=`pwd`

#Create empty result file
touch $OutputFile
if [ ! -e $OutputFile ]
then
  echo "Unable to create output file: $OutputFile" >> $LogFileName
  exit 1
fi

#Connect to FTP Host
ftpscript="aaa.ftp"
totalflist="filelistall"

getlist() {
  ltmpfile="tmpfile$1"`date +%y%m%d%H%M%S`
  echo "open $Host" > $ltmpfile
  echo "user $Username $Password" >> $ltmpfile
  echo "dir $2 $3$1" >> $ltmpfile
  echo "bye" >> $ltmpfile
  ftp -n < $ltmpfile
  rm $ltmpfile
}

getfile() {
  ltmpfile="tmpfile$1"`date +%y%m%d%H%M%S`
  echo "Getting file $2/$3" >> $LogFileName
  echo "open $Host" > $ltmpfile
  echo "user $Username $Password" >> $ltmpfile
  echo "cd $2" >> $ltmpfile
  echo "get $3" >> $ltmpfile
  echo "bye" >> $ltmpfile
  ftp -n < $ltmpfile
  rm $ltmpfile
}

delfile() {
  ltmpfile="tmpfile$1"`date +%y%m%d%H%M%S`
  echo "Removing remote file $2/$3" >> $LogFileName
  echo "open $Host" > $ltmpfile
  echo "user $Username $Password" >> $ltmpfile
  echo "cd $2" >> $ltmpfile
  echo "delete $3" >> $ltmpfile
  echo "bye" >> $ltmpfile
  for aa in `ftp -n < $ltmpfile`
  do
    echo "Unable to remove remote file $2/$3" >> $LogFileName
  done
  rm $ltmpfile
}

getcopyfulllist() {
  echo "preparing directory $2" 
  getlist $1 $2 $4
  for aa in `grep "^-" $4$1 | sed -e 's/^-[rswx-][rwsx-]*  *[0-9][0-9]*  *[^ ][^ ]*  *[^ ][^ ]*  *[0-9][0-9]*  *[^ ][^ ]*  *[0-9][0-9]*  *[^ ][^ ]*  *\(.*\)$/\1/'` 
  do
    if ( echo $aa | grep $AuditPrefix >> /dev/null )
    then 
      echo $2/$aa >> $3
      getfile $1 $2 $aa
      if [ ! -e $aa ]
      then
        echo "Error getting file $2/$aa" >> $LogFileName
        exitf
      fi
      if [ -e $tmpfile ]
      then 
        rm $tmpfile
      fi
      if ( ! mv $OutputFile $tmpfile )
      then
        echo "Unable to rename \"$OutputFile\" to \"$tmpfile\"" >> $LogFileName
        exitf
      fi 
      if ( ! cat $aa > $OutputFile )
      then
        echo "Error appending file \"$aa\" to \"$tmpfile\""
        exitf
      fi
      if ( ! cat $tmpfile >> $OutputFile )
      then
        echo "Error appending file \"$aa\" to \"$tmpfile\""
        exitf
      fi
      rm $aa
      delfile $1 $2 $aa
    fi
  done
  for aa in `grep "^d" $4$1 | sed -e 's/^d[rswx-][rwsx-]*  *[0-9][0-9]*  *[^ ][^ ]*  *[^ ][^ ]*  *[0-9][0-9]*  *[^ ][^ ]*  *[0-9][0-9]*  *[^ ][^ ]*  *\(.*\)$/\1/'` 
  do
    level="${1}1"
    getcopyfulllist $level "$2/$aa" $3 $4
  done
  rm "$4$1"
}

ltmpfile="tmpfile"`date +%y%m%d%H%M%S`
echo "open $Host" > $ltmpfile
echo "user $Username $Password" >> $ltmpfile
echo "bye" >> $ltmpfile
for aa in `ftp -n < $ltmpfile`
do
  rm $ltmpfile
  echo "Unable to connect to ftp host: $Host" >> $LogFileName
  exitf
done
rm $ltmpfile
#Get FileList and copy files from FTP Host
if [ -e $tmpfilelistname ]
then 
  rm $tmpfilelistname
fi

getcopyfulllist 1 $CopySubVolume $tmpfilelistname $tmpfilelistname1

#Exit if no files
if [ ! -e $tmpfilelistname ] 
then
  echo "No files on FTP Host to download" >> $LogFileName
  exitf
else
  rm $tmpfilelistname
fi

if [ -e $tmpfile ]
then 
  rm $tmpfile
fi

